const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Permissoes_moduloDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const permissoes_modulo = await db.permissoes_modulo.create(
      {
        id: data.id || undefined,

        modulo: data.modulo || null,
        leitura: data.leitura || false,

        escrita: data.escrita || false,

        aprovacao: data.aprovacao || false,

        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await permissoes_modulo.setRole(data.role || null, {
      transaction,
    });

    await permissoes_modulo.setClientes(data.clientes || null, {
      transaction,
    });

    return permissoes_modulo;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const permissoes_moduloData = data.map((item, index) => ({
      id: item.id || undefined,

      modulo: item.modulo || null,
      leitura: item.leitura || false,

      escrita: item.escrita || false,

      aprovacao: item.aprovacao || false,

      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const permissoes_modulo = await db.permissoes_modulo.bulkCreate(
      permissoes_moduloData,
      { transaction },
    );

    // For each item created, replace relation files

    return permissoes_modulo;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const permissoes_modulo = await db.permissoes_modulo.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.modulo !== undefined) updatePayload.modulo = data.modulo;

    if (data.leitura !== undefined) updatePayload.leitura = data.leitura;

    if (data.escrita !== undefined) updatePayload.escrita = data.escrita;

    if (data.aprovacao !== undefined) updatePayload.aprovacao = data.aprovacao;

    updatePayload.updatedById = currentUser.id;

    await permissoes_modulo.update(updatePayload, { transaction });

    if (data.role !== undefined) {
      await permissoes_modulo.setRole(
        data.role,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await permissoes_modulo.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return permissoes_modulo;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const permissoes_modulo = await db.permissoes_modulo.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of permissoes_modulo) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of permissoes_modulo) {
        await record.destroy({ transaction });
      }
    });

    return permissoes_modulo;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const permissoes_modulo = await db.permissoes_modulo.findByPk(id, options);

    await permissoes_modulo.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await permissoes_modulo.destroy({
      transaction,
    });

    return permissoes_modulo;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const permissoes_modulo = await db.permissoes_modulo.findOne(
      { where },
      { transaction },
    );

    if (!permissoes_modulo) {
      return permissoes_modulo;
    }

    const output = permissoes_modulo.get({ plain: true });

    output.role = await permissoes_modulo.getRole({
      transaction,
    });

    output.clientes = await permissoes_modulo.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.roles,
        as: 'role',

        where: filter.role
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.role
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.role
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.modulo) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('permissoes_modulo', 'modulo', filter.modulo),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.leitura) {
        where = {
          ...where,
          leitura: filter.leitura,
        };
      }

      if (filter.escrita) {
        where = {
          ...where,
          escrita: filter.escrita,
        };
      }

      if (filter.aprovacao) {
        where = {
          ...where,
          aprovacao: filter.aprovacao,
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.permissoes_modulo.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('permissoes_modulo', 'modulo', query),
        ],
      };
    }

    const records = await db.permissoes_modulo.findAll({
      attributes: ['id', 'modulo'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['modulo', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.modulo,
    }));
  }
};
